diff -r 1e55e1aa8b7f sys/netinet/tcp_output.c
--- a/sys/netinet/tcp_output.c	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_output.c	Fri Jul 11 13:32:06 2014 +1000
@@ -37,10 +37,13 @@
 #include "opt_ipsec.h"
 #include "opt_tcpdebug.h"
 
+#include <sys/endian.h>
+
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/domain.h>
 #include <sys/hhook.h>
+#include <sys/kdb.h>
 #include <sys/kernel.h>
 #include <sys/lock.h>
 #include <sys/mbuf.h>
@@ -50,6 +53,7 @@
 #include <sys/socket.h>
 #include <sys/socketvar.h>
 #include <sys/sysctl.h>
+#include <sys/taskqueue.h>
 
 #include <net/if.h>
 #include <net/route.h>
@@ -80,7 +84,8 @@
 #ifdef TCP_OFFLOAD
 #include <netinet/tcp_offload.h>
 #endif
-
+#include <netinet/mptcp.h>
+#include <netinet/mptcp_var.h>
 #ifdef IPSEC
 #include <netipsec/ipsec.h>
 #endif /*IPSEC*/
@@ -94,7 +99,7 @@
 	&VNET_NAME(path_mtu_discovery), 1,
 	"Enable Path MTU Discovery");
 
-VNET_DEFINE(int, tcp_do_tso) = 1;
+VNET_DEFINE(int, tcp_do_tso) = 0;
 #define	V_tcp_do_tso		VNET(tcp_do_tso)
 SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, tso, CTLFLAG_RW,
 	&VNET_NAME(tcp_do_tso), 0,
@@ -128,6 +133,9 @@
 			    long len, int tso);
 static void inline	cc_after_idle(struct tcpcb *tp);
 
+static void inline 	mp_addoptions(struct tcpopt *to,
+				u_int *optlen_ptr, u_char *optp);
+
 /*
  * Wrapper for the TCP established output helper hook.
  */
@@ -161,6 +169,361 @@
 		CC_ALGO(tp)->after_idle(tp->ccv);
 }
 
+static void inline
+mp_addoptions(struct tcpopt *to, u_int *optlen_ptr, u_char *optp) {
+	struct mp_capable mcap;
+
+	uint64_t mask = 0;
+	for (mask = 1; mask < MPOF_MAXOPT; mask <<= 1) {
+		if ((to->to_mopts.mpo_flags & mask) != mask)
+			continue;
+		if (*optlen_ptr == TCP_MAXOLEN)
+			break;
+		switch (to->to_mopts.mpo_flags & mask)
+		{
+		case MPOF_CAPABLE_SYN:
+		{
+			/*
+			 * Note that keys are stored in network order, so
+			 * do no need to call htobe64 before bcopy
+			 */
+			mcap.kind = TCPOPT_MPTCP;
+			mcap.ver_sub = MPTCP_SUBTYPE_MP_CAPABLE;
+
+			uint8_t cap_flags = 0;
+			cap_flags |= USE_SHA1; // hard coded in sha1
+			cap_flags &= ~USE_CSUM; // don't support csumming yet
+
+			if (to->to_mopts.mpo_flags & MPOF_USE_CSUM) {
+				cap_flags |= USE_CSUM;
+			}
+			/* sending a SYN */
+
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_CAPABLE_SYN)
+				break;
+
+			mcap.length = MPTCP_SUBLEN_MP_CAPABLE_SYN;
+
+			/* SYN (or SYNACK), just include the local key */
+			u_int64_t key = to->to_mopts.local_key;
+
+			/* MP_CAPABLE type/flags */
+			*optlen_ptr += MPTCP_SUBLEN_MP_CAPABLE_SYN;
+			*optp++ = mcap.kind;
+			*optp++ = mcap.length;
+			*optp++ = 0; // version and subtype are 0
+			*optp++ = cap_flags;
+
+			/* copy in the key s*/
+			bcopy((u_char *)&key, optp, sizeof(key));
+			optp += sizeof(key);
+
+			/*
+			 * Indicate to caller that the capable option has been
+			 * copied into the outgoing TCP header.
+			 */
+			to->to_mopts.mpo_flags &= ~MPOF_CAPABLE_SYN;
+			break;
+		}
+		case MPOF_CAPABLE_ACK:
+		{
+			uint8_t cap_flags = 0;
+			/* ACK of 3-way handshake */
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_CAPABLE_ACK)
+				break;
+
+			u_int64_t local_key = to->to_mopts.local_key;
+			u_int64_t remote_key = to->to_mopts.remote_key;
+
+			*optlen_ptr += MPTCP_SUBLEN_MP_CAPABLE_ACK;
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = MPTCP_SUBLEN_MP_CAPABLE_ACK;
+			*optp++ = 0;	// just manually setting
+			*optp++ = cap_flags;
+
+			/* and copy in the local key */
+			bcopy((u_char *)&local_key, optp, sizeof(local_key));
+			optp += sizeof(local_key);
+
+			/* echo the remote key */
+			bcopy((u_char *)&remote_key, optp, sizeof(remote_key));
+			optp += sizeof(remote_key);
+
+			break;
+		}
+		case MPOF_MP_JOIN: /* Sending a MP_JOIN SYN Option */
+		{
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_JOIN_SYN)
+				break;
+
+			uint8_t subtype = MPTCP_SUBTYPE_MP_JOIN;
+
+			/*
+			 * XXXNJW: just assuming for now that SYNs are sent as subflows
+			 * are added
+			 */
+			uint8_t addrID = to->to_mopts.addr_id;
+
+			subtype = (subtype << 4);
+
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = MPTCP_SUBLEN_MP_JOIN_SYN;
+			*optp++ = (MPTCP_SUBTYPE_MP_JOIN << 4);	// XXXNJW manually setting
+
+			*optlen_ptr += MPTCP_SUBLEN_MP_JOIN_SYN;
+			*optp++ = addrID;
+
+			bcopy((u_char *)&to->to_mopts.rcv_token,
+					optp, sizeof(to->to_mopts.rcv_token));
+			optp += sizeof(to->to_mopts.rcv_token);
+
+			bcopy((u_char *)&to->to_mopts.snd_rnd,
+					optp, sizeof(to->to_mopts.snd_rnd));
+			optp += sizeof(to->to_mopts.snd_rnd);
+
+			break;
+		}
+		case MPOF_JOIN_SYN: /* Sending a MP_JOIN SYNACK Option */
+		{
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_JOIN_SYNACK)
+				break;
+
+			uint8_t subtype = MPTCP_SUBTYPE_MP_JOIN;
+			subtype = (subtype << 4);
+
+			*optlen_ptr += MPTCP_SUBLEN_MP_JOIN_SYNACK;
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = MPTCP_SUBLEN_MP_JOIN_SYNACK;
+			*optp++ = subtype;
+			*optp++ = (uint8_t) to->to_mopts.addr_id;
+
+			bcopy((u_char *)&to->to_mopts.truncated_MAC,
+			    optp, sizeof(to->to_mopts.truncated_MAC));
+			optp += sizeof(to->to_mopts.truncated_MAC);
+
+			bcopy((u_char *)&to->to_mopts.snd_rnd,
+			    optp, sizeof(to->to_mopts.snd_rnd));
+			optp += sizeof(to->to_mopts.snd_rnd);
+			break;
+		}
+		case MPOF_JOIN_SYNACK: /* Sending a MP_JOIN ACK Option */
+		{
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_JOIN_ACK) {
+				break;
+			}
+
+			uint8_t subtype = MPTCP_SUBTYPE_MP_JOIN;
+			subtype = (subtype << 4);
+
+			*optlen_ptr += (uint8_t) MPTCP_SUBLEN_MP_JOIN_ACK;
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = MPTCP_SUBLEN_MP_JOIN_ACK;
+			*optp++ = subtype;
+			/* the last 12-bits after subtype are reserved (zeroed) */
+			*optp++ = 0;
+
+			/* Copy full HMAC-A into option */
+			bcopy(to->to_mopts.snd_mac, optp, 20);
+			optp += 20;
+			break;
+		}
+		case MPOF_DSS:
+		{
+			uint8_t subtype = MPTCP_SUBTYPE_DSS;
+			uint8_t dss_opts = 0;
+			uint8_t length = 4; /* the initial 4 bytes of option */
+
+			/* Set flags for DSS */
+	//		if (to->to_mopts.mpo_flags & MPOF_DATA_FIN) {
+	//			printf("adding Data-fin\n");
+	//			dss_opts |= FIN_PRESENT;
+	//		}
+
+			if (to->to_mopts.mpo_flags & MPOF_DATA_ACK) {
+				dss_opts |= ACK_PRESENT;
+				length += 4;
+
+				if (to->to_mopts.mpo_flags & MPOF_ACK64) {
+					dss_opts |= ACK_64_PRESENT;
+					length += 4;
+				}
+			}
+
+			if (to->to_mopts.mpo_flags & MPOF_DSN_MAP) {
+				dss_opts |= MAP_PRESENT;
+				length += 4;
+
+				length += 4;	/* subflow sequence num */
+				length += 2;	/* data length */
+
+				if(to->to_mopts.mpo_flags & MPOF_USE_CSUM)
+					length += 2;
+
+				if (to->to_mopts.mpo_flags & MPOF_DSN64) {
+					length += 4;
+					dss_opts |= DSN_64;
+				}
+			}
+
+			if (TCP_MAXOLEN - *optlen_ptr < length)
+				break;
+
+			*optlen_ptr += length;
+
+			// pad it out to divide by 4 to prevent EOL being inserted
+			// before our option
+			// XXXNJW kind of a hack, to fix
+			if (*optlen_ptr % 4) {
+				*optlen_ptr += TCPOLEN_NOP;
+				*optp++ = TCPOPT_NOP;
+				*optlen_ptr += TCPOLEN_NOP;
+				*optp++ = TCPOPT_NOP;
+			}
+
+			/* option kind and length fields */
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = length;
+
+			/* subtype and flags */
+			subtype = (subtype << 4);
+			bcopy((u_char *)&subtype, optp, sizeof(uint8_t));
+			optp += sizeof(uint8_t);
+			to->to_mopts.dss_opts_f_p = (uint8_t*) optp;
+			bcopy((u_char *)&dss_opts, optp, sizeof(uint8_t));
+			optp += sizeof(uint8_t);
+
+			/* copy the Data ACK */
+			if (to->to_mopts.mpo_flags & MPOF_DATA_ACK) {
+				if (to->to_mopts.mpo_flags & MPOF_ACK64) {
+					u_int64_t data_ack_num = to->to_mopts.data_ack_num;
+					data_ack_num = htobe64(data_ack_num);
+					bcopy((u_char *)&data_ack_num, optp, sizeof(data_ack_num));
+					optp += sizeof(data_ack_num);
+				} else {
+					u_int32_t data_ack_num =
+					    (uint32_t) to->to_mopts.data_ack_num;
+					data_ack_num = htonl(data_ack_num);
+					bcopy((u_char *)&data_ack_num, optp, sizeof(data_ack_num));
+					optp += sizeof(data_ack_num);
+				}
+			}
+
+			/* DSN contents */
+			if (to->to_mopts.mpo_flags & MPOF_DSN_MAP) {
+				uint32_t data_seq_num = (uint32_t) to->to_mopts.data_seq_num;
+				/* DSN and SSN */
+				if (to->to_mopts.mpo_flags & MPOF_DSN64) {
+					to->to_mopts.data_seq_num =
+							htobe64(to->to_mopts.data_seq_num);
+					bcopy((u_char *)&to->to_mopts.data_seq_num,
+							optp, sizeof(to->to_mopts.data_seq_num));
+					optp += sizeof(to->to_mopts.data_seq_num);
+				} else {
+					data_seq_num = htonl(data_seq_num);
+					bcopy((u_char *)&data_seq_num, optp, sizeof(data_seq_num));
+					optp += sizeof(data_seq_num);
+				}
+
+				to->to_mopts.sub_seq_num = htonl(to->to_mopts.sub_seq_num);
+				bcopy((u_char *)&to->to_mopts.sub_seq_num, optp,
+					sizeof(to->to_mopts.sub_seq_num));
+				optp += sizeof(to->to_mopts.sub_seq_num);
+
+				/* Length */
+				to->to_mopts.dss_data_len = htons(to->to_mopts.dss_data_len);
+				bcopy((u_char *)&to->to_mopts.dss_data_len, optp,
+					sizeof(to->to_mopts.dss_data_len));
+				optp += sizeof(to->to_mopts.dss_data_len);
+
+				if(to->to_mopts.mpo_flags & MPOF_USE_CSUM) {
+					to->to_mopts.dss_csum = htons(to->to_mopts.dss_csum);
+					bcopy((u_char *)&to->to_mopts.dss_csum, optp,
+						sizeof(to->to_mopts.dss_csum));
+					optp += sizeof(to->to_mopts.dss_csum);
+				}
+			}
+
+			/*
+			 * We process both at once so can clear flags to prevent
+			 * processing twice.
+			 */
+			to->to_mopts.mpo_flags &= ~MPOF_DSN_MAP;
+			to->to_mopts.mpo_flags &= ~MPOF_DATA_ACK;
+			break;
+		}
+		case MPOF_ADD_ADDR:
+		{
+			struct mp_add address;
+			int i, addr_id, addr_len = 0;
+			void * addr = NULL;
+
+			address.length = address.sub_ipver = 0;
+
+			/* The list of addresses should be locked at this point. */
+			/* Loop through the available addresses. */
+			for (i = 0; i < to->to_mopts.address_count; i++) {
+				/* continue if there are addresses to advertise */
+				if (!(to->to_mopts.add_addr_mask & (1 << i)))
+					continue;
+
+				switch (mp_usable_addresses[i].ss_family) {
+					case AF_INET:
+						addr = &((struct sockaddr_in *)
+							&mp_usable_addresses[i])->sin_addr.s_addr;
+						address.length = MPTCP_SUBLEN_ADD_ADDRV4;
+						address.sub_ipver = 4;
+						addr_len = 4;
+						break;
+					case AF_INET6:
+						addr = &((struct sockaddr_in6 *)
+							&mp_usable_addresses[i])->sin6_addr.__u6_addr;
+						address.length = MPTCP_SUBLEN_ADD_ADDRV6;
+						address.sub_ipver = 6;
+						addr_len = 16;
+						break;
+				}
+
+				if (TCP_MAXOLEN - *optlen_ptr < address.length)
+					break;
+
+				/* mark address as advertised. Need to pass this back to the
+				 * mpcb */
+				to->to_mopts.add_addr_mask &= ~(1 << i);
+
+				*optlen_ptr += address.length;
+				*optp++ = TCPOPT_MPTCP;
+				*optp++ = address.length;
+
+				/* subtype and IPVer */
+				uint8_t subtype = (MPTCP_SUBTYPE_ADD_ADDR << 4);
+				subtype |= address.sub_ipver;
+				bcopy((u_char *)&subtype, optp, sizeof(uint8_t));
+				optp ++;
+
+				/* Minus 1 as we never send add_addr for the master subflow */
+				addr_id = i - 1;
+
+				/* Address ID */
+				bcopy((u_char *)&addr_id, optp, sizeof(uint8_t));
+				optp ++;
+
+				bcopy((u_char *)addr, optp, addr_len);
+				optp += addr_len;
+			}
+			break;
+		}
+		case MPOF_REMOVE_ADDR:
+			break;
+		case MPOF_MP_FAIL:
+			break;
+		case MPOF_FASTCLOSE:
+			break;
+		default:
+			break;
+		}
+	}
+}
+
 /*
  * Tcp output routine: figure out what should be sent and send it.
  */
@@ -169,7 +532,8 @@
 {
 	struct socket *so = tp->t_inpcb->inp_socket;
 	long len, recwin, sendwin;
-	int off, flags, error = 0;	/* Keep compiler happy */
+	int off = 0, flags, map_offset = 0, map_unsent, error = 0;	/* Keep compiler happy */
+	struct ds_map *snd_dsmap;
 	struct mbuf *m;
 	struct ip *ip = NULL;
 	struct ipovly *ipov = NULL;
@@ -217,6 +581,7 @@
 			idle = 0;
 		}
 	}
+
 again:
 	/*
 	 * If we've recently taken a timeout, snd_max will be greater than
@@ -229,10 +594,15 @@
 	sendalot = 0;
 	tso = 0;
 	mtu = 0;
+	flags = tcp_outflags[tp->t_state];
+
+	sendwin = min(tp->snd_wnd, tp->snd_cwnd);
 	off = tp->snd_nxt - tp->snd_una;
-	sendwin = min(tp->snd_wnd, tp->snd_cwnd);
+	KASSERT(SEQ_GEQ(tp->snd_nxt, tp->snd_una) && SEQ_LEQ(tp->snd_nxt, tp->snd_max),
+	    ("%s: snd_nxt not valid: %u, snd_una: %u, snd_max: %u",
+	    __func__, tp->snd_nxt, tp->snd_una, tp->snd_max));
 
-	flags = tcp_outflags[tp->t_state];
+
 	/*
 	 * Send any SACK-generated retransmissions.  If we're explicitly trying
 	 * to send out new data (when sendalot is 1), bypass this function.
@@ -240,6 +610,7 @@
 	 * we're replacing a (future) new transmission with a retransmission
 	 * now, and we previously incremented snd_cwnd in tcp_input().
 	 */
+
 	/*
 	 * Still in sack recovery , reset rxmit flag to zero.
 	 */
@@ -250,8 +621,8 @@
 	if ((tp->t_flags & TF_SACK_PERMIT) && IN_FASTRECOVERY(tp->t_flags) &&
 	    (p = tcp_sack_output(tp, &sack_bytes_rxmt))) {
 		long cwin;
-		
-		cwin = min(tp->snd_wnd, tp->snd_cwnd) - sack_bytes_rxmt;
+
+		cwin = sendwin - sack_bytes_rxmt;
 		if (cwin < 0)
 			cwin = 0;
 		/* Do not retransmit SACK segments beyond snd_recover */
@@ -269,6 +640,7 @@
 				 * moves past p->rxmit.
 				 */
 				p = NULL;
+				tp->snd_nxt = tp->snd_max;			//XXXNJW experimenting
 				goto after_sack_rexmit;
 			} else
 				/* Can rexmit part of the current hole */
@@ -276,15 +648,17 @@
 						   tp->snd_recover - p->rxmit));
 		} else
 			len = ((long)ulmin(cwin, p->end - p->rxmit));
-		off = p->rxmit - tp->snd_una;
-		KASSERT(off >= 0,("%s: sack block to the left of una : %d",
-		    __func__, off));
+		//off = p->rxmit - tp->snd_una;
+
 		if (len > 0) {
+			tp->snd_nxt = p->rxmit;					//XXXNJW experimenting
 			sack_rxmit = 1;
 			sendalot = 1;
 			TCPSTAT_INC(tcps_sack_rexmits);
 			TCPSTAT_ADD(tcps_sack_rexmit_bytes,
 			    min(len, tp->t_maxseg));
+		} else {
+			tp->snd_nxt = tp->snd_max;
 		}
 	}
 after_sack_rexmit:
@@ -297,7 +671,26 @@
 	if (tp->t_flags & TF_NEEDSYN)
 		flags |= TH_SYN;
 
-	SOCKBUF_LOCK(&so->so_snd);
+	/* XXXNJW IS_MASTER_TP test used to prevent maps from being added once
+	 * application has issued a close
+	 */
+	if((flags & TH_FIN && tp->snd_nxt == tp->snd_max)
+	    || tp->t_state >= TCPS_FIN_WAIT_1
+	    || (!IS_MASTER_TP(tp) && !tp->mp_active))
+		snd_dsmap = NULL;
+	else
+		snd_dsmap = mp_find_dsmap(tp, tp->snd_nxt);
+
+	if (snd_dsmap) {
+	    map_offset = off - (snd_dsmap->sf_seq_start - tp->snd_una);
+	    map_unsent = snd_dsmap->ds_map_len - map_offset;
+	} else {
+		map_unsent = 0;
+	}
+
+	// XXXNJW: double check the typcasting here.
+	recwin = (long) mp_get_recwin(tp->t_mpcb);
+
 	/*
 	 * If in persist timeout with window of 0, send 1 byte.
 	 * Otherwise, if window is small but nonzero
@@ -322,7 +715,8 @@
 			 * to send then the probe will be the FIN
 			 * itself.
 			 */
-			if (off < so->so_snd.sb_cc)
+			if ((map_offset < snd_dsmap->ds_map_len) && snd_dsmap ==
+				TAILQ_FIRST(&tp->t_txdsmaps))
 				flags &= ~TH_FIN;
 			sendwin = 1;
 		} else {
@@ -347,28 +741,31 @@
 	 * in which case len is already set.
 	 */
 	if (sack_rxmit == 0) {
-		if (sack_bytes_rxmt == 0)
-			len = ((long)ulmin(so->so_snd.sb_cc, sendwin) - off);
-		else {
+		if (sack_bytes_rxmt == 0) {
+			/* XXXNJW: sets len to 0 if the cwnd has dipped below a single map.
+			 * this is in place for debuggine only. in practice want to send
+			 * even partial maps */
+			int avail_window = (sendwin - off) > 1420 ? (sendwin - off) : 0;
+			len = (long)ulmin(map_unsent, avail_window);
+		} else {
 			long cwin;
 
-                        /*
+             /*
 			 * We are inside of a SACK recovery episode and are
 			 * sending new data, having retransmitted all the
 			 * data possible in the scoreboard.
 			 */
-			len = ((long)ulmin(so->so_snd.sb_cc, tp->snd_wnd) 
-			       - off);
+			len = (long)ulmin(map_unsent, tp->snd_wnd);
 			/*
 			 * Don't remove this (len > 0) check !
-			 * We explicitly check for len > 0 here (although it 
-			 * isn't really necessary), to work around a gcc 
+			 * We explicitly check for len > 0 here (although it
+			 * isn't really necessary), to work around a gcc
 			 * optimization issue - to force gcc to compute
 			 * len above. Without this check, the computation
 			 * of len is bungled by the optimizer.
 			 */
 			if (len > 0) {
-				cwin = tp->snd_cwnd - 
+				cwin = tp->snd_cwnd -
 					(tp->snd_nxt - tp->sack_newdata) -
 					sack_bytes_rxmt;
 				if (cwin < 0)
@@ -378,6 +775,9 @@
 		}
 	}
 
+//	if (sendwin - off < 0 && len > 0)
+//		kdb_break();
+
 	/*
 	 * Lop off SYN bit if it has already been sent.  However, if this
 	 * is SYN-SENT state and if segment contains data and if we don't
@@ -394,7 +794,8 @@
 	 * This measure is needed to prevent interoperability problems
 	 * with not fully conformant TCP implementations.
 	 */
-	if ((flags & TH_SYN) && (tp->t_flags & TF_NOOPT)) {
+	if (((flags & TH_SYN) && (tp->t_flags & TF_NOOPT))
+			|| (tp->t_mpcb->mp_flags & MPO_GOTJOINSYNACK)) {
 		len = 0;
 		flags &= ~TH_FIN;
 	}
@@ -423,6 +824,23 @@
 	/* len will be >= 0 after this point. */
 	KASSERT(len >= 0, ("[%s:%d]: len < 0", __func__, __LINE__));
 
+	if (len)
+		KASSERT(snd_dsmap != NULL, ("%s: Segment has length but no send map\n",
+		    __func__));
+
+//	if (snd_dsmap) {
+//		/* some debugging. this generally happens when sending at the upper
+//		 * end of the cwnd (there are some bytes but not enough to send a
+//		 * map/1-MSS. should wind up at 'just_return' */
+//		if (len < snd_dsmap->ds_map_len) {
+//			printf("%s: sendwin %ld len %ld map_len %u snd_nxt %u\n", __func__,
+//				sendwin, len, snd_dsmap->ds_map_len, tp->snd_nxt);
+//			printf("%s: map_unsent %d\n", __func__, map_unsent);
+//			if ((snd_dsmap->ds_map_len > 0) && (len == 0))
+//				kdb_break();
+//		}
+//	}
+
 	/*
 	 * Automatic sizing of send socket buffer.  Often the send buffer
 	 * size is not optimally adjusted to the actual network conditions
@@ -458,17 +876,25 @@
 	 * with congestion window.  Requires another timer.  Has to
 	 * wait for upcoming tcp timer rewrite.
 	 */
-	if (V_tcp_do_autosndbuf && so->so_snd.sb_flags & SB_AUTOSIZE) {
+
+	/* XXXNJW: Move snd buf adjustments into mp-level. Don't want individual
+	 * subflows adjusting the buffer sizes. should be the responsibility of
+	 * the scheduler. Having sf-level adjustments will probably limit the
+	 * throughput (eventually).
+	 */
+	SOCKBUF_LOCK(&so->so_snd);
+	if (V_tcp_do_autosndbuf && (so->so_snd.sb_flags & SB_AUTOSIZE)) {
 		if ((tp->snd_wnd / 4 * 5) >= so->so_snd.sb_hiwat &&
-		    so->so_snd.sb_cc >= (so->so_snd.sb_hiwat / 8 * 7) &&
-		    so->so_snd.sb_cc < V_tcp_autosndbuf_max &&
-		    sendwin >= (so->so_snd.sb_cc - (tp->snd_nxt - tp->snd_una))) {
+			so->so_snd.sb_cc >= (so->so_snd.sb_hiwat / 8 * 7) &&
+			so->so_snd.sb_cc < V_tcp_autosndbuf_max &&
+			sendwin >= (so->so_snd.sb_cc - (tp->snd_nxt - tp->snd_una))) {
 			if (!sbreserve_locked(&so->so_snd,
-			    min(so->so_snd.sb_hiwat + V_tcp_autosndbuf_inc,
-			     V_tcp_autosndbuf_max), so, curthread))
+				min(so->so_snd.sb_hiwat + V_tcp_autosndbuf_inc,
+				 V_tcp_autosndbuf_max), so, curthread))
 				so->so_snd.sb_flags &= ~SB_AUTOSIZE;
 		}
 	}
+	SOCKBUF_UNLOCK(&so->so_snd);
 
 	/*
 	 * Decide if we can use TCP Segmentation Offloading (if supported by
@@ -498,6 +924,9 @@
 	    tp->t_inpcb->in6p_options == NULL)
 		tso = 1;
 
+	/* XXXNJW: Must take care of this direct access to so_snd. Leave in for now
+	 * as this calculation is important when trying to rexmit an unanswered
+	 * FIN */
 	if (sack_rxmit) {
 		if (SEQ_LT(p->rxmit + len, tp->snd_una + so->so_snd.sb_cc))
 			flags &= ~TH_FIN;
@@ -506,13 +935,13 @@
 			flags &= ~TH_FIN;
 	}
 
-	recwin = sbspace(&so->so_rcv);
-
 	/*
 	 * Sender silly window avoidance.   We transmit under the following
 	 * conditions when len is non-zero:
 	 *
-	 *	- We have a full segment (or more with TSO)
+	 *	- We have a full segment (or more with TSO) OR
+	 *	  A map's size is smaller than the MSS, or we are at
+	 *	  the end of a map (bytes remaining are < MSS).
 	 *	- This is the last buffer in a write()/send() and we are
 	 *	  either idle or running NODELAY
 	 *	- we've timed out (e.g. persist timer)
@@ -521,18 +950,17 @@
 	 *	- we need to retransmit
 	 */
 	if (len) {
-		if (len >= tp->t_maxseg)
-			goto send;
+//		if (len >= tp->t_maxseg ||												//never the case with restricted, per-packet maps
+//		    (map_unsent > 0 && map_unsent == len))					      		// when we are running out of window len will be less
+		if (len >= 1420)
+			goto send;      													// than the remaining map to send (most likely)
 		/*
 		 * NOTE! on localhost connections an 'ack' from the remote
 		 * end may occur synchronously with the output and cause
 		 * us to flush a buffer queued with moretocome.  XXX
-		 *
-		 * note: the len + off check is almost certainly unnecessary.
 		 */
 		if (!(tp->t_flags & TF_MORETOCOME) &&	/* normal case */
 		    (idle || (tp->t_flags & TF_NODELAY)) &&
-		    len + off >= so->so_snd.sb_cc &&
 		    (tp->t_flags & TF_NOPUSH) == 0) {
 			goto send;
 		}
@@ -596,14 +1024,11 @@
 		/* 
 		 * If the new window size ends up being the same as the old
 		 * size when it is scaled, then don't force a window update.
+		 *
 		 */
 		if (oldwin >> tp->rcv_scale == (adv + oldwin) >> tp->rcv_scale)
 			goto dontupdate;
-
-		if (adv >= (long)(2 * tp->t_maxseg) &&
-		    (adv >= (long)(so->so_rcv.sb_hiwat / 4) ||
-		     recwin <= (long)(so->so_rcv.sb_hiwat / 8) ||
-		     so->so_rcv.sb_hiwat <= 8 * tp->t_maxseg))
+		if (adv >= (long) (2 * tp->t_maxseg))
 			goto send;
 	}
 dontupdate:
@@ -660,21 +1085,28 @@
 	 * if window is nonzero, transmit what we can,
 	 * otherwise force out a byte.
 	 */
-	if (so->so_snd.sb_cc && !tcp_timer_active(tp, TT_REXMT) &&
+	if (map_unsent && !tcp_timer_active(tp, TT_REXMT) &&
 	    !tcp_timer_active(tp, TT_PERSIST)) {
 		tp->t_rxtshift = 0;
 		tcp_setpersist(tp);
 	}
 
+//	/* sf was assigned a map, but wasn't able to transmit (e.g. due to limited
+//	 * send window). Make sure that SFF_DATA_WAIT is set so that the scheduler
+//	 * will use this sf next time through usr_send */
+//	if (tp->mp_active && snd_dsmap && ((tp->sf_flags & SFF_DATA_WAIT) == 0)) {
+//		tp->sf_flags |= SFF_DATA_WAIT;
+//		atomic_add_acq_int(&tp->t_mpcb->data_wait_count, 1);
+//		taskqueue_enqueue(taskqueue_swi, &tp->t_mpcb->data_task);
+//	}
+
 	/*
 	 * No reason to send a segment, just return.
 	 */
 just_return:
-	SOCKBUF_UNLOCK(&so->so_snd);
 	return (0);
 
 send:
-	SOCKBUF_LOCK_ASSERT(&so->so_snd);
 	/*
 	 * Before ESTABLISHED, force sending of initial options
 	 * unless TCP set not to do any options.
@@ -691,6 +1123,9 @@
 #endif
 		hdrlen = sizeof (struct tcpiphdr);
 
+	if (flags & TH_RST)
+		mp_debug(MPSESSION, 4, 0,"%s: state closed, in send\n", __func__);
+
 	/*
 	 * Compute options for segment.
 	 * We only have to care about SYN and established connection
@@ -699,6 +1134,8 @@
 	 */
 	if ((tp->t_flags & TF_NOOPT) == 0) {
 		to.to_flags = 0;
+		to.to_mopts.mpo_flags = 0;
+
 		/* Maximum segment size. */
 		if (flags & TH_SYN) {
 			tp->snd_nxt = tp->iss;
@@ -710,6 +1147,174 @@
 			to.to_wscale = tp->request_r_scale;
 			to.to_flags |= TOF_SCALE;
 		}
+
+		if (tp->mp_enabled) {
+			/*
+			 * If SYN and mp_enabled, should check if this is the initial
+			 * connection attempt on the master subflow. The master subflow
+			 * should have an MP_CAPABLE option, while a subflow will have
+			 * an MP_JOIN option
+			 */
+			if (flags & TH_SYN) {
+				/* Multipath announce capable, for SYN and SYN/ACK */
+				if (IS_MASTER_TP(tp)) {
+					tp->sent_capable = 1;
+
+					to.to_flags |= TOF_MPTCP;
+					to.to_mopts.mpo_flags |= MPOF_CAPABLE_SYN;
+
+					to.to_mopts.local_key =
+							tp->t_mpcb->local_key;
+					//if (tp->t_mpcb->mp_status & CSUM_ENABLED)
+						//to.to_mopts.mpo_flags |= MPOF_USE_CSUM;
+				} else {
+					/* A SYN on a subflow that isn't the master, use MP_JOIN
+					 * MP is active on this subflow, since we wouldn't try to
+					 * send a join on a non-mptcp connection. */
+					tp->sent_capable = 1;
+					tp->mpc = 1;
+					tp->mp_enabled = 1;
+					to.to_flags |= TOF_MPTCP;
+					to.to_mopts.mpo_flags |= MPOF_MP_JOIN;
+					to.to_mopts.rcv_token =
+							tp->t_mpcb->remote_token;
+					to.to_mopts.snd_rnd = arc4random();
+					// XXXNJW not good, but ensures add_id starts at "0"
+					to.to_mopts.addr_id = tp->t_mpcb->subflow_cnt - 1;
+					tp->local_rand = to.to_mopts.snd_rnd;
+				}
+			}
+
+			/* received a SYNACK with MP_CAPABLE */
+			if (tp->sf_flags & SFF_GOT_SYNACK) {
+				tp->sf_flags &= ~SFF_GOT_SYNACK;
+				/* got a synack after sending capable */
+
+				if (tp->sent_capable) {
+					to.to_flags |= TOF_MPTCP;
+					to.to_mopts.mpo_flags |= MPOF_CAPABLE_ACK;
+					to.to_mopts.local_key =
+							tp->t_mpcb->local_key;
+					to.to_mopts.remote_key =
+							tp->t_mpcb->remote_key;
+
+				}
+			}
+
+			/* Received a SYNACK with MP_JOIN */
+			if (tp->sf_flags & SFF_GOT_JOIN_SYNACK) {
+				/* XXX: should clear this only when we know that the
+				 * option has been copied into a packet.
+				 */
+				tp->sf_flags &= ~SFF_GOT_JOIN_SYNACK;
+
+				/* XXX: Should set this state only when we know the
+				 * option has been put into packet */
+				tp->sf_state = MPS_PRE_ESTABLISHED;
+
+				/* Must send full HMAC-A as third part of MP_JOIN
+				 * handshake */
+				to.to_mopts.snd_mac = tp->hmac_local;
+
+				/* Add an MP_JOIN_ACK to the outgoing packet */
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |= MPOF_JOIN_SYNACK;
+			}
+		}
+
+		/* do these options only once mptcp is established */
+		if ((tp->mp_active == 1) &&
+		    (tp->t_mpcb->mp_state >= MPS_ESTABLISHED)) {
+			
+			/*
+			 * Need to add an ADD_ADDR on the next outgoing packet if asked to
+			 * or if all available addresses have not yet been advertised
+			 */
+			if (tp->t_mpcb->mp_advaddr_mask) {
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |= MPOF_ADD_ADDR;
+				to.to_mopts.add_addr_mask = tp->t_mpcb->mp_advaddr_mask;
+				to.to_mopts.address_count = tp->t_mpcb->mp_conn_address_count;
+				to.to_mopts.addr_id = tp->t_mpcb->subflow_cnt - 1;
+
+				taskqueue_enqueue(taskqueue_swi, &tp->t_mpcb->pcb_create_task);
+			}
+
+			/*
+			 * If there are addresses that we have added that have not yet
+			 * attempted a join, schedule one now.
+			 */
+			if (tp->t_mpcb->mp_advjoin_mask)
+				taskqueue_enqueue(taskqueue_swi, &tp->t_mpcb->join_task);
+
+			/*
+			 * Need to attach a DATA-ACK to the outgoing packet
+			 * MPO_DATA_ACK is set in tcp_reass when in-order
+			 * data segments are provided to the process. currently
+			 * this works like an ACK_NOW, and will be put onto any
+			 * outgoing segment.
+			 *
+			 * XXX: provide a callout to do time-delayed Data-ACKs
+			 */
+
+			if ((tp->sf_flags & SFF_NEED_DACK) ||
+					(tp->t_mpcb->mp_flags & MPO_DATA_ACK)) {
+				tp->sf_flags &= ~SFF_NEED_DACK;
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |= (MPOF_DATA_ACK | MPOF_DSS);
+				// should check against session settings
+				//to.to_mopts.mpo_flags |= MPOF_DSS;
+				//to.to_mopts.mpo_flags |= MPOF_ACK64;
+				to.to_mopts.data_ack_num =
+						(uint32_t) tp->t_mpcb->ds_rcv_nxt;
+			}
+
+			/* Only put a map on the first packet */
+			if (len && ((map_offset == 0 && snd_dsmap->ds_map_len > tp->t_maxseg)
+					|| (snd_dsmap->ds_map_len <= tp->t_maxseg)))
+				to.to_mopts.mpo_flags |= MPOF_DSN_MAP;
+
+			/* need to build a DSS MAP for the outgoing packet */
+			if (to.to_mopts.mpo_flags & MPOF_DSN_MAP) {
+				/* XXXNJW: implement checks for csum and dsn64 */
+				//to.to_mopts.mpo_flags |= MPOF_USE_CSUM; //XXX: temp
+				//to.to_mopts.mpo_flags |= MPOF_DSN64;	//XXX: temp
+
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |= MPOF_DSS;
+
+				/*
+				 * Add offset in the case of rexmits, inserting option in
+				 * multiple packets for a single map
+				 */
+				to.to_mopts.sub_seq_num =
+				    (snd_dsmap->sf_seq_start + map_offset - tp->iss);
+
+				//XXXNJW wrapping...
+				/*
+				 * Do not need to adjust ds mapping - we just re-send the
+				 * map start.
+				 */
+				to.to_mopts.data_seq_num =
+				    (uint32_t) snd_dsmap->ds_map_start + map_offset;			// added offset in case of partial rexmits
+
+				/* Length */
+				to.to_mopts.dss_data_len = snd_dsmap->ds_map_len - map_offset;	// adjust for the end of the mapping
+
+				/* received a SYNACK with MP_JOIN */
+				if (tp->t_mpcb->mp_flags & MPO_GOTJOINSYNACK) {
+					tp->t_mpcb->mp_flags &= ~MPO_GOTJOINSYNACK;
+					/* got a synack after sending capable */
+
+					to.to_flags |= TOF_MPTCP;
+					to.to_mopts.mpo_flags |= MPOF_JOIN_ACK;
+
+					// would also add the MAC/nonce here.
+				}
+
+			}
+		}
+
 		/* Timestamps. */
 		if ((tp->t_flags & TF_RCVD_TSTMP) ||
 		    ((flags & TH_SYN) && (tp->t_flags & TF_REQ_TSTMP))) {
@@ -743,6 +1348,12 @@
 		hdrlen += optlen = tcp_addoptions(&to, opt);
 	}
 
+	/* update the address masks */
+	if (to.to_mopts.mpo_flags & MPOF_ADD_ADDR) {
+		to.to_mopts.mpo_flags &= ~MPOF_ADD_ADDR;
+		tp->t_mpcb->mp_advaddr_mask = to.to_mopts.add_addr_mask;
+	}
+
 #ifdef INET6
 	if (isipv6)
 		ipoptlen = ip6_optlen(tp->t_inpcb);
@@ -757,6 +1368,7 @@
 	ipoptlen += ipsec_optlen;
 #endif
 
+
 	/*
 	 * Adjust data length if insertion of options will
 	 * bump the packet length beyond the t_maxopd length.
@@ -786,7 +1398,7 @@
 			 * fractional unless the send sockbuf can
 			 * be emptied.
 			 */
-			if (sendalot && off + len < so->so_snd.sb_cc) {
+			if (sendalot && map_offset + len < map_unsent) {
 				len -= len % (tp->t_maxopd - optlen);
 				sendalot = 1;
 			}
@@ -832,9 +1444,6 @@
 	 * the template for sends on this connection.
 	 */
 	if (len) {
-		struct mbuf *mb;
-		u_int moff;
-
 		if ((tp->t_flags & TF_FORCEDATA) && len == 1)
 			TCPSTAT_INC(tcps_sndprobe);
 		else if (SEQ_LT(tp->snd_nxt, tp->snd_max) || sack_rxmit) {
@@ -853,29 +1462,24 @@
 			m = m_gethdr(M_NOWAIT, MT_DATA);
 
 		if (m == NULL) {
-			SOCKBUF_UNLOCK(&so->so_snd);
 			error = ENOBUFS;
 			sack_rxmit = 0;
 			goto out;
 		}
-
 		m->m_data += max_linkhdr;
 		m->m_len = hdrlen;
 
 		/*
-		 * Start the m_copy functions from the closest mbuf
-		 * to the offset in the socket buffer chain.
+		 * Start the m_copy functions from the map's mbuf_start mbuf.
 		 */
-		mb = sbsndptr(&so->so_snd, off, len, &moff);
-
 		if (len <= MHLEN - hdrlen - max_linkhdr) {
-			m_copydata(mb, moff, (int)len,
-			    mtod(m, caddr_t) + hdrlen);
+			m_copydata(snd_dsmap->mbuf_start, snd_dsmap->mbuf_offset +
+			    map_offset, (int)len, mtod(m, caddr_t) + hdrlen);
 			m->m_len += len;
 		} else {
-			m->m_next = m_copy(mb, moff, (int)len);
+			m->m_next = m_copy(snd_dsmap->mbuf_start,
+				snd_dsmap->mbuf_offset + map_offset, (int)len);
 			if (m->m_next == NULL) {
-				SOCKBUF_UNLOCK(&so->so_snd);
 				(void) m_free(m);
 				error = ENOBUFS;
 				sack_rxmit = 0;
